<?php
namespace Zeedhi\Framework\Socket\Server\Client;

/**
 * Class ClientProviderImpl
 *
 * @package Zeedhi\Framework\Socket\Client
 */
class ClientProviderImpl implements ClientProviderInterface {
	/** @var ClientImpl */
	protected $clients = [];

	/**
	 * {@inheritDoc}
	 */
	public function findByAccessToken($accessToken = null) {
		if ($accessToken === null) {
			$client = new ClientImpl();
			$this->clients[$client->getAccessToken()] = $client;
		} else {
			$client = $this->clients[$accessToken] ?? null;
		}

		return $client;
	}

	/**
	 * {@inheritDoc}
	 */
	public function updateClient(ClientInterface $client) {
		if (isset($this->clients[$client->getAccessToken()])) {
			$this->clients[$client->getAccessToken()] = $client;
		}
	}
}